<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_CLASS_ALBUMFUNCTIONS_INCLUDED') ) {
	define ('_OPN_CLASS_ALBUMFUNCTIONS_INCLUDED', 1);

	class AlbumFunctions {

		/*<{4php5}>var!!public<{4php5/}>*//*<{delete}>*/ var /*<{delete/}>*/ $table = '';
		// table with parent-child structure

		/*<{4php5}>var!!public<{4php5/}>*//*<{delete}>*/ var /*<{delete/}>*/ $_where = '';

		/*<{4php5}>var!!public<{4php5/}>*//*<{delete}>*/ var /*<{delete/}>*/ $itemtable = '';
		// items table with each item associated with an id in table $table

		/*<{4php5}>var!!public<{4php5/}>*//*<{delete}>*/ var /*<{delete/}>*/ $itemid = '';
		// unique id for records in table $itemtable

		/*<{4php5}>var!!public<{4php5/}>*//*<{delete}>*/ var /*<{delete/}>*/ $itemlink = '';

		/*<{4php5}>var!!public<{4php5/}>*//*<{delete}>*/ var /*<{delete/}>*/ $itemwhere = '';

		/**
		 * Class constructor
		 * 		
		 * @param $where
		 * @param $themegroup
		 */
		function /*<{4php5}>AlbumFunctions!!__construct<{4php5/}>*//*<{delete}>*/AlbumFunctions/*<{delete/}>*/ ($where = true, $themegroup = false) {

			global $opnTables;

			$this->table = $opnTables['mediagallery_albums'];
			$this->itemtable = $opnTables['mediagallery_pictures'];
			$this->itemid = 'pid';
			$this->itemlink = 'aid';
			if ($where) {
				$this->_buildwhere ($themegroup);
			}
		}

		/**
		* returns the total number of items in items table that
		* are accociated with a given table $table id
		*
		* @param int $sel_id
		* @param string $status
		* @return int
		**/

		function getTotalItems ($sel_id, $status = 1) {

			global $opnConfig;

			$count = 0;
			$link = $this->itemlink;
			$where = '';
			if ($this->itemwhere != '') {
				$where = ' AND ' . $this->itemwhere;
			}
			$query = 'SELECT COUNT(' . $this->itemid . ') AS counter from ' . $this->itemtable . ' WHERE ' . $link . '=' . $sel_id;
			$query .= $where;
			$query .= ' AND approved =' . $status;
			$result = &$opnConfig['database']->Execute ($query);
			if ($result !== false) {
				if ( ($result->fields !== false) && (isset ($result->fields['counter']) ) ) {
					$count = $result->fields['counter'];
					$result->Close ();
				}
			}
			return $count;

		}

		/**
		* makes a nicely ordered selection box
		* $preset_id is used to specify a preselected item
		* set $none to 1 to add a option with value 0
		*
		* @param int $preset_id
		* @param object $form
		* @param int $none
		* @param string $selname
		* @param bool $ownid
		* @return bool $hasitems - success
		**/

		function makeMySelBox ($preset_id = 0, &$form, $cat_id = 0, $selname = '', $ownid = false) {

			global $opnConfig;
			if ($selname == '') {
				$selname = 'aid';
			}
			$where = '';
			if ($this->_where != '') {
				$where = ' AND ' . $this->_where;
			}
			$result = &$opnConfig['database']->Execute ('SELECT aid, title FROM ' . $this->table . ' WHERE cid=' . $cat_id . $where . ' ORDER BY pos');
			$options = array ();
			$selected = '';
			$hasitems = false;
			if ($result !== false) {
				while (! $result->EOF) {
					$catid = $result->fields['aid'];
					if ( ($ownid === false) || ($ownid != intval ($catid) ) ) {
						$name = $result->fields['title'];
						$options[$catid] = $name;
						if ($catid == $preset_id) {
							$selected = $catid;
						}
						$hasitems = true;
					}
					$result->MoveNext ();
				}
				$result->Close ();
			}
			$form->AddSelect ($selname, $options, $selected);
			return $hasitems;

		}

		/**
		* Returns an array with the albums for cid
		 * 		
		 * @param $default_image
		 * @param $url
		 * @param $mediaobject
		 * @param $cid
		 * @param $uid
		 * @return array
		 */
		function GetAlbumTemplate ($default_image, $url, &$mediaobject, $cid = 0, $uid = 0) {

			global $opnConfig, $opnTables;

			$where = ' WHERE ';
			$where .= ' cid =' . $cid;
			$isuid = false;
			if (!is_array ($uid) ) {
				$where .= ' AND uid =' . $uid;
				if ($uid) {
					$isuid = true;
				}
			} else {
				$isuid = true;
				$where .= ' AND uid IN (' . implode (',', $uid) . ')';
			}
			if ( ($this->_where != '') && (!$isuid) ) {
				$where .= ' AND ' . $this->_where;
			}
			$order = ' ORDER BY pos';
			$result = &$opnConfig['database']->Execute ('SELECT aid, title, image, description, uid FROM ' . $this->table . $where . ' ' . $order);
			$albums = array ();
			$item = 0;
			if ($result !== false) {
				$item = 0;
				while (! $result->EOF) {
					$aid = $result->fields['aid'];
					$name = $result->fields['title'];
					$image = $result->fields['image'];
					$desc = $result->fields['description'];
					$uid = $result->fields['uid'];
					$counter = $this->getTotalItems ($aid);
					opn_nl2br ($desc);
					// if ($counter) {
					if (!$image) {
						$image = $default_image;
					}
					if ($image) {
						$image = urldecode ($image);
						if (substr_count ($image, 'http://') == 0) {
							$image = $opnConfig['datasave']['mediagallery_albums']['url'] . '/' . $image;
						}
					}
					$url['aid'] = $aid;
					$albums[$item]['url'] = $url;
					$albums[$item]['name'] = $name;
					$albums[$item]['image'] = $image;
					$albums[$item]['description'] = $desc;
					$counter = $this->GetItemCount ('a.aid='.$aid . ' AND approved=1', $uid);
					$albums[$item]['countmedia'] = $counter;
					$albums[$item]['lastchange'] = '';
					$albums[$item]['lastchangestring'] = '';
					$result1 = $opnConfig['database']->SelectLimit ('SELECT ctime FROM ' . $opnTables['mediagallery_pictures'] . ' WHERE aid='.$aid . ' ORDER BY ctime DESC', 1);
					if (!$result1->EOF) {
						$ctime = $result1->fields['ctime'];
						$opnConfig['opndate']->sqlToopnData ($ctime);
						$time = '';
						$opnConfig['opndate']->formatTimestamp ($time, _DATE_DATESTRING4);
						$newest = buildnewtag ($ctime);
						$albums[$item]['lastchange'] = $time;
						$albums[$item]['newest'] = $newest;
					}
					$result1->Close ();
					$albums[$item]['adminmenu'] = $mediaobject->_BuildAlbumMenu ($uid, $url, $albums, $item);
					$item++;
					// }
					$result->MoveNext ();
				}
				$result->Close ();
			}
			return $albums;

		}

		function getNameFromId ($id) {

			global $opnConfig;

			$name = '';
			$result = $opnConfig['database']->Execute ('SELECT title FROM ' . $this->table . ' WHERE aid='.$id);
			if ($result !== false) {
				while (!$result->EOF) {
					$name = $result->fields['title'];
					$result->MoveNext ();
				}
				$result->Close ();
			}
			return $name;
		}

		function getCommentsFromId ($id) {

			global $opnConfig;

			$comments = 0;
			$result = $opnConfig['database']->Execute ('SELECT comments FROM ' . $this->table . ' WHERE aid='.$id);
			if ($result !== false) {
				while (!$result->EOF) {
					$comments = $result->fields['comments'];
					$result->MoveNext ();
				}
				$result->Close ();
			}
			return $comments;

		}

		function getVotesFromId ($id) {

			global $opnConfig;

			$votes = 0;
			$result = $opnConfig['database']->Execute ('SELECT votes FROM ' . $this->table . ' WHERE aid='.$id);
			if ($result !== false) {
				while (!$result->EOF) {
					$votes = $result->fields['votes'];
					$result->MoveNext ();
				}
				$result->Close ();
			}
			return $votes;

		}

		function getEcardFromId ($id) {

			global $opnConfig;

			$ecard = 0;
			$result = $opnConfig['database']->Execute ('SELECT ecard FROM ' . $this->table . ' WHERE aid='.$id);
			if ($result !== false) {
				while (!$result->EOF) {
					$ecard = $result->fields['ecard'];
					$result->MoveNext ();
				}
				$result->Close ();
			}
			return $ecard;

		}

		function getCatFromId ($id) {

			global $opnConfig;

			$name = '';
			$result = $opnConfig['database']->Execute ('SELECT cid FROM ' . $this->table . ' WHERE aid='.$id);
			if ($result !== false) {
				while (!$result->EOF) {
					$name = $result->fields['cid'];
					$result->MoveNext ();
				}
				$result->Close ();
			}
			return $name;
		}

		function getUserFromId ($id) {

			global $opnConfig;

			$name = '';
			$result = $opnConfig['database']->Execute ('SELECT uid FROM ' . $this->table . ' WHERE aid='.$id);
			if ($result !== false) {
				while (!$result->EOF) {
					$name = $result->fields['uid'];
					$result->MoveNext ();
				}
				$result->Close ();
			}
			return $name;
		}

		/**
		* Returns a comma separeted list with the visible albums
		*
		* @param $cid
		* @return string
		*/

		function GetAlbumList ($cid, $uid = 0) {

			global $opnConfig, $opnTables;

			$where = ' WHERE ';
			$where .= ' (cid IN (' . $cid . ') OR ';
			$where .= ' (cid = 0 AND uid > 0))';
			$isuid = false;
			if (!is_array ($uid) ) {
				$where .= ' AND (uid =' . $uid . ')';
				if ($uid) {
					$isuid = true;
				}
			} else {
				$isuid = true;
				$where .= ' AND (uid IN (' . implode (',', $uid) . '))';
			}
			if ( ($this->_where != '') && (!$isuid) ) {
				$where .= ' AND ' . $this->_where;
			}
			$order = ' ORDER BY aid';
			$result = &$opnConfig['database']->Execute ('SELECT aid FROM ' . $this->table . $where . ' ' . $order);
			$albums = array ();
			if ($result !== false) {
				while (! $result->EOF) {
					$catid = $result->fields['aid'];
					$albums[] = $catid;
					$result->MoveNext ();
				}
				$result->Close ();
			}
			$albums = implode (',', $albums);
			if ($albums == '') {
				$albums = 0;
			}
			return $albums;

		}

		/**
		* Returns a comma separeted list with the visible albums
		*
		* @param $cid
		* @return string
		*/

		function GetAlbumListAll ($cid) {

			global $opnConfig, $opnTables;

			$where = ' WHERE ';
			$where .= ' (cid IN (' . $cid . ') OR ';
			$where .= ' (cid = 0 AND uid > 0))';
			if ( ($this->_where != '')) {
				$where .= ' AND ' . $this->_where;
			}
			$order = ' ORDER BY aid';
			$result = &$opnConfig['database']->Execute ('SELECT aid FROM ' . $this->table . $where . ' ' . $order);
			$albums = array ();
			if ($result !== false) {
				while (! $result->EOF) {
					$catid = $result->fields['aid'];
					$albums[] = $catid;
					$result->MoveNext ();
				}
				$result->Close ();
			}
			$albums = implode (',', $albums);
			if ($albums == '') {
				$albums = 0;
			}
			return $albums;

		}

		/**
		* Returns a comma separeted list with the visible albums
		*
		* @param $cid
		* @return string
		*/

		function GetAlbumListCat ($cid) {

			global $opnConfig, $opnTables;

			$where = ' WHERE ';
			$where .= ' cid IN (' . $cid . ')';
			if ( ($this->_where != '')) {
				$where .= ' AND ' . $this->_where;
			}
			$order = ' ORDER BY aid';
			$result = &$opnConfig['database']->Execute ('SELECT aid FROM ' . $this->table . $where . ' ' . $order);
			$albums = array ();
			if ($result !== false) {
				while (! $result->EOF) {
					$catid = $result->fields['aid'];
					$albums[] = $catid;
					$result->MoveNext ();
				}
				$result->Close ();
			}
			$albums = implode (',', $albums);
			if ($albums == '') {
				$albums = 0;
			}
			return $albums;

		}

		/**
		 * Returns a comma separated albumlist
		 * 
		 * @param $cid
		 * @param $uid
		 * @access public
		 * @return string
		 */
		function GetAlbumListThumbs ($cid, $uid, &$catobject) {

			global $opnConfig, $opnTables;

			$where = ' WHERE ';
			if ($cid == 0) {
				$where .= ' cid = 0 AND uid > 0';
			} else {
				if ($cid == -1) {
					$cid = $catobject->GetCatList ();
					if ($cid == '') {
						$cid = 0;
					}
				} else {
					if ($cid) {
						$test = $catobject->getAllChildId ($cid);
						$test[] = $cid;
						$cid = implode (',', $test);
						unset($test);
					}
				}
				if ($uid == 0) {
					$where .= ' cid IN (' . $cid . ')';
				} elseif ($uid < 0) {
					$where .= ' (cid IN (' . $cid . ') OR ';
					$where .= ' (cid = 0 AND uid > 0))';
				} else {
					$where .= ' (cid = 0 AND uid > 0)';
				}
			}
			$isuid = false;
			if ($uid > 0) {
				$where .= ' AND (uid =' . $uid . ')';
				$isuid = true;
			} elseif ($uid == 0) {
				$isuid = true;
			}
			if ( ($this->_where != '') && (!$isuid) ) {
				$where .= ' AND ' . $this->_where;
			}
			$order = ' ORDER BY aid';
			$result = &$opnConfig['database']->Execute ('SELECT aid FROM ' . $this->table . $where . ' ' . $order);
			$albums = array ();
			if ($result !== false) {
				while (! $result->EOF) {
					$catid = $result->fields['aid'];
					$albums[] = $catid;
					$result->MoveNext ();
				}
				$result->Close ();
			}
			$albums = implode (',', $albums);
			if ($albums == '') {
				$albums = 0;
			}
			return $albums;

		}

		/**
		* returns a array for the sitemap
		*
		* @param 	array	$hlp1	The returnarray
		* @param 	int		$indent	The starting indent
		* @param	string	$url	The navurl
		* @param 	string	$item	The Itemname
		*/

		function BuildSitemap (&$hlp1, $indent, $url, $item, $cat_id) {

			global $opnConfig, $opnTables;

			$where = '';
			if ($this->_where != '') {
				$where = ' AND ' . $this->_where;
			}
			$url['op'] = 'view_album';
			$indent++;
			$result = &$opnConfig['database']->Execute ('SELECT aid, title FROM ' . $this->table . ' WHERE cid=' . $cat_id . $where . ' ORDER BY pos');
			while (! $result->EOF) {
				$id = $result->fields['aid'];
				$name = $result->fields['title'];
				$count = $this->getTotalItems ($id);
				if ($count>0) {
					$url['aid'] = $id;
					$hlp1[] = array ('url' => $url,
							'name' => $name,
							'item' => $item . $id,
							'indent' => $indent);
				}
				$result->MoveNext ();
			}
			$result->Close ();

		}

		/**
		* Returns the Itemresultset.
		*
		* @param 	array	$fields		The fieldlist
		* @param 	array	$orderby	The Order By fields
		* @param 	string	$where		The Itemwehere clausel
		* @return 	object	The Resultset
		*/

		function &GetItemResult ($fields, $orderby, $where = '', $group = '', $isowner = false) {

			global $opnConfig;

			$sql = '';
			$this->_buildsql ($sql, $fields, $orderby, $where, $group, false, 0, false, $isowner);
			$result = &$opnConfig['database']->Execute ($sql);
			return $result;

		}

		/**
		* Returns the Itemresultset via SelectLimit
		*
		* @param 	array	$fields		The Fieldlist
		* @param 	array	$orderby	The Order By fields
		* @param 	string	$where		The Itemwhere clausel
		* @param 	int		$limit		The Limit
		* @return 	object	The Resultset
		*/

		function &GetItemLimit ($fields, $orderby, $limit, $where = '', $offset = 0, $isowner = false, $totaluser = false) {

			global $opnConfig;

			$sql = '';
			$this->_buildsql ($sql, $fields, $orderby, $where, '', false, 0, $totaluser, $isowner);
			$result = &$opnConfig['database']->SelectLimit ($sql, $limit, $offset);
			return $result;

		}

		/**
		 * Returns the Items and comments via SelectLimit
		 * 		
		 * @param $limit
		 * @param $where
		 * @param $offset
		 * @return object
		 */
		function &GetItemCommentsLimit ($limit, $where, $offset) {

			global $opnConfig, $opnTables;

			$sql = 'SELECT p.pid as pid, p.aid as aid, p.filename as filename, p.filesize as filesize, ';
			$sql .= 'p.pwidth as pwidth, p.pheight as pheight, p.hits as hits, p.mtime as mtime, ';
			$sql .= 'p.ctime as ctime, p.uid as uid, p.rating as rating, p.votes as votes, ';
			$sql .= 'p.title as title, p.copyright as copyright, p.keywords as keywords, ';
			$sql .= 'p.description as description, p.approved as approved, c.wdate as wdate, ';
			$sql .= 'p.nwidth as nwidth, p.nheight  as nheight, ';
			$sql .= 'c.name as name, c.comment as comment FROM ' . $opnTables['mediagallery_pictures'];
			$sql .= ' p, ' . $opnTables['mediagallery_comments'] . ' c';
			$where1 = ' WHERE p.approved=1 AND c.sid=p.pid';
			if ($where != '') {
				$where1 .= ' AND ' . $where;
			}
			$sql .= $where1;
			$sql .= ' ORDER BY c.wdate DESC';
			$result = &$opnConfig['database']->SelectLimit ($sql, $limit, $offset);
			return $result;
		}

		/**
		 * Returns the comments count
		 * 		
		 * @param $where
		 * @return int
		 */
		function GetItemCommentsCount ($where) {

			global $opnConfig, $opnTables;

			$sql = 'SELECT COUNT(c.tid) as counter FROM ' . $opnTables['mediagallery_pictures'];
			$sql .= ' p, ' . $opnTables['mediagallery_comments'] . ' c';
			$where1 = ' WHERE p.approved=1 AND c.sid=p.pid';
			if ($where != '') {
				$where1 .= ' AND ' . $where;
			}
			$sql .= $where1;
			$result = &$opnConfig['database']->Execute ($sql);
			if ( ($result !== false) && (isset ($result->fields['counter']) ) ) {
				$dnum = $result->fields['counter'];
				$result->Close ();
			} else {
				$dnum = 0;
			}
			return $dnum;
		}

		/**
		* Returns the Itemcounter
		*
		* @return int	The Itemcounter
		*/

		function GetItemCount ($itemwhere = '', $uid = 0, $totalusers = false, $isowner = false) {

			global $opnConfig;

			$sql = '';
			$this->_buildsql ($sql, '', array (),
								$itemwhere,
								'',
								1,
								$uid,
								$totalusers,
								$isowner);
			$result = &$opnConfig['database']->Execute ($sql);
			if ( ($result !== false) && (isset ($result->fields['counter']) ) ) {
				$dnum = $result->fields['counter'];
				$result->Close ();
			} else {
				$dnum = 0;
			}
			return $dnum;

		}

		function GetItemNewest ($itemwhere = '', $totaluser = false) {

			$result = $this->GetItemLimit( array ('ctime'), array ('i.ctime DESC'), 1, $itemwhere, 0, false, $totaluser);
			if ( ($result !== false) && (isset ($result->fields['ctime']) ) ) {
				$dnum = $result->fields['ctime'];
				$result->Close ();
			} else {
				$dnum = 0;
			}
			return $dnum;
		}

		/**
		* Returns the Itemhits
		*
		* @return int	The Itemhits
		*/

		function GetItemHits ($itemwhere = '', $uid = 0, $totalusers = false) {

			global $opnConfig;

			$sql = '';
			$this->_buildsql ($sql, '', array (),
								$itemwhere,
								'',
								2,
								$uid,
								$totalusers);
			$result = &$opnConfig['database']->Execute ($sql);
			if ( ($result !== false) && (isset ($result->fields['counter']) ) ) {
				$dnum = $result->fields['counter'];
				$result->Close ();
			} else {
				$dnum = 0;
			}
			return $dnum;

		}

		/**
		* Count the albhums.
		*
		* @return int	The Albumcount
		*/

		function GetAlbumCount ($uid = 0, $totaluser = false, $uploads = false) {

			global $opnConfig;

			$where = '';
			if ( ($this->_where != '') && ($uid == 0) && (!$totaluser) ) {
				$where = ' WHERE ' . $this->_where;
				if ($uploads) {
					$where .= ' AND uploads=1';
				}
			} elseif ($totaluser) {
				$where = ' WHERE cid=0 AND uid>0';
			} else {
				$where = ' WHERE uid=' . $uid;
			}
			$result = &$opnConfig['database']->Execute ('SELECT COUNT(aid) AS counter FROM ' . $this->table . $where);
			if ( ($result !== false) && (isset ($result->fields['counter']) ) ) {
				$cat = $result->fields['counter'];
				$result->Close ();
			} else {
				$cat = 0;
			}
			return $cat;

		}

		/**
		* Generate the Item SQL Statement
		*
		* @param 	string	$sql		Holds the SQL Statement
		* @param 	array	$fields		The Fieldlist
		* @param 	array	$orderby	The Order By fields
		* @param 	string	$itemwhere	The Itemwhere Clausel
		*/

		function _buildsql (&$sql, $fields, $orderby, $itemwhere, $group = '', $count = false, $uid = 0, $totalusers = false, $isowner = false) {

			global $opnConfig, $opnTables;

			$where = '';
			$this->_builditemwhere ($where, $itemwhere, $uid, $totalusers, $isowner);
			switch ($count) {
				case 1:
					// Count
					$sql = 'SELECT COUNT(i.' . $this->itemid . ') AS counter FROM ' . $this->itemtable . ' i';
					break;
				case 2:
					// SUM(hits)
					$sql = 'SELECT SUM(i.hits) AS counter FROM ' . $this->itemtable . ' i';
					break;
				default:
					$max = count ($fields);
					for ($i = 0; $i< $max; $i++) {
						$fields[$i] = 'i.' . $fields[$i] . ' AS ' . $fields[$i];
					}
					$fieldlist = implode (',', $fields);
					$orderlist = implode (',', $orderby);
					$sql = 'SELECT ' . $fieldlist . ' FROM ' . $this->itemtable . ' i';
					break;
			}

			/* switch */

			$sql .= ', ' . $this->table . ' a ';
			if ($isowner) {
				$sql .= ', ' . $opnTables['users'] . ' u ';
			}
			$sql.= $where;
			if ($group != '') {
				$sql .= ' GROUP BY ' . $group;
			}
			if (count ($orderby) ) {
				$sql .= ' ORDER BY ' . $orderlist;
			}
			unset ($where);

		}

		function _checkand (&$where) {
			if ($where != ' WHERE ') {
				$where .= ' AND ';
			}

		}

		/**
		* Build the Wherestatement for the Itemquery
		*
		* @param	string	$where		The Where Statement
		* @param 	string	$itemwhere	The Itemwhereclausel
		*/

		function _builditemwhere (&$where, $itemwhere, $uid = 0, $totaluser = false, $isowner = false) {

			global $opnConfig;

			$where = ' WHERE ';
			$where .= 'i.' . $this->itemlink . '=a.aid';
			if ($itemwhere != '') {
				$this->_checkand ($where);
				$where .= $itemwhere;
			}
			if ($this->itemwhere != '') {
				$this->_checkand ($where);
				$where .= $this->itemwhere;
			}
			if ( ($this->_where != '') && ($uid == 0) && (!$totaluser) ) {
				$checkerlist = $opnConfig['permission']->GetUserGroups ();
				$this->_checkand ($where);
				$where .= '(a.usergroup IN (' . $checkerlist . '))';
				if ( (isset ($opnConfig['opnOption']['themegroup']) ) && ($opnConfig['opnOption']['themegroup'] >= 1) ) {
					$this->_checkand ($where);
					$where .= "((a.themegroup='" . $opnConfig['opnOption']['themegroup'] . "') OR (a.themegroup=0))";
				}
				unset ($checkerlist);
			} elseif ($uid>0) {
				$this->_checkand ($where);
				$where .= 'a.uid=' . $uid;
			} else {
				$this->_checkand ($where);
				$where .= 'a.cid=0 AND a.uid>0';
			}
			if ($isowner) {
				$this->_checkand ($where);
				$where .= '(i.uid = u.uid)';
			}
			if ($where == ' WHERE ') {
				$where = '';
			}

		}

		/**
		* Generate the Where Statement for the SQL querys.
		*
		*/

		function _buildwhere ($themegroup = false) {

			global $opnConfig;

			$this->_where = '';
			if ($themegroup) {
				if ( (isset ($opnConfig['opnOption']['themegroup']) ) && ($opnConfig['opnOption']['themegroup'] >= 1) ) {
					$this->_where .= "((themegroup='" . $opnConfig['opnOption']['themegroup'] . "') OR (themegroup=0))";
				}
			}
			$checkerlist = $opnConfig['permission']->GetUserGroups ();
			if ($this->_where != '') {
				$this->_where .= ' AND ';
			}
			$this->_where .= '(usergroup IN (' . $checkerlist . '))';
			unset ($checkerlist);

		}

	}
}

?>