<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/

if (!defined ('_OPN_MAINFILE_INCLUDED') ) { die(); }

if (!defined ('_OPN_MEDIAGALLERY_FILEFUNCTIONS_INCLUDED') ) {
	define ('_OPN_MEDIAGALLERY_FILEFUNCTIONS_INCLUDED', 1);
	include_once (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.file.php');
	define ('_PATH_MEDIA', 0);
	define ('_PATH_UPLOAD', 1);
	define ('_PATH_TEMP', 2);
	define ('_PATH_BATCH', 3);

	define ('_THUMB_NORMAL', 0);
	define ('_THUMB_SIDEBOX', 1);
	define ('_THUMB_CENTERBOX', 2);
	define ('_THUMB_THUMB', 3);

	if (!defined('IMAGETYPE_JPEG')) {
		define('IMAGETYPE_JPEG', 2);
	}

	if (!defined('IMAGETYPE_PNG')) {
		define('IMAGETYPE_PNG', 3);
	}

	class FileFunctions {

		/*<{4php5}>var!!private<{4php5/}>*//*<{delete}>*/ var /*<{delete/}>*/ $_mediafunctions;

		/*<{4php5}>var!!private<{4php5/}>*//*<{delete}>*/ var /*<{delete/}>*/ $_imageobject;

		/*<{4php5}>var!!private<{4php5/}>*//*<{delete}>*/ var /*<{delete/}>*/ $_file_failure = array ();

		/*<{4php5}>var!!private<{4php5/}>*//*<{delete}>*/ var /*<{delete/}>*/ $_file_success = array ();

		/**
		* Sets the Imageobject
		*
		* @param $imageobject
		*/

		function SetImageObject (&$imageobject) {

			$this->_imageobject = $imageobject;

		}

		/**
		* Sets the Mediaobject
		*
		* @param $imageobject
		*/

		function SetMediaobject (&$mediaobject) {

			$this->_mediafunctions = $mediaobject;

		}

		/**
		* Returns the files that are not uploaded.
		*
		* @return array
		*/

		function GetFailures () {
			return $this->_file_failure;

		}

		/**
		* Returns the array with the uploaded mediafiles.
		*
		* @return array
		*/

		function GetSuccess () {
			return $this->_file_success;

		}

		/**
		* Builds the mediafilename.
		* With this function the users can upload a file with the same filename
		*
		* @param $filename
		* @param $media_id
		* @param $new
		* @param $url
		* @param $upload
		* @return string
		*/

		function getAttachmentFilename ($filename, $media_id, $new = false, $url = false, $path = _PATH_MEDIA) {

			global $opnConfig;
			// Remove special accented characters - ie. s.
			$clean_name = strtr ($filename, '', 'SZszYAAAAAACEEEEIIIINOOOOOOUUUUYaaaaaaceeeeiiiinoooooouuuuyy');
			$clean_name = strtr ($clean_name, array ('' => 'TH',
								'' => 'th',
								'' => 'DH',
								'' => 'dh',
								'' => 'ss',
								'' => 'OE',
								'' => 'oe',
								'' => 'AE',
								'' => 'ae',
								'' => 'u') );
			// Sorry, no spaces, dots, or anything else but letters allowed.
			$clean_name = preg_replace (array ('/\s/',
							'/[^\w_\.\-]/'),
							array ('_',
				''),
				$clean_name);
			$clean_name = str_replace ('%20', '_', $clean_name);
			$ext = (strstr ($clean_name, '.')?'.' . strtolower (substr (strrchr ($clean_name, '.'), 1) ) : '');
			$enc_name = $media_id . '_' . str_replace ('.', '_', $clean_name) . md5 ($clean_name) . $ext;
			if ($media_id === false) {
				return $clean_name;
			}
			if ($media_id == 0) {
				$enc_name = $clean_name;
			}

			switch ($path) {
				case _PATH_UPLOAD:
					$index = 'mediagallery_upload';
					break;
				case _PATH_TEMP:
					$index = 'mediagallery_temp';
					break;
				case _PATH_BATCH:
					$index = 'mediagallery_batch';
					break;
				default:
					$index = 'mediagallery_media';
					break;
			}

			/* switch */
			if ($new) {
				return $enc_name;
			}
			$dir = $opnConfig['datasave'][$index]['url'] . '/';
			if (!$url) {
				$dir = $opnConfig['datasave'][$index]['path'];
			}
			$filename = $dir . $enc_name;
			return $filename;

		}

		/**
		* Deletes a mediafile
		*
		* @param $media_id
		* @param $filename
		* @param $upload
		*/

		function DeleteFile ($media_id, $filename, $path = _PATH_MEDIA) {

			$filename = $this->getAttachmentFilename ($filename, $media_id, false, false, $path);
			if (file_exists ($filename) ) {
				$file =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opnFile ();
				$file->delete_File ($filename);
				if ($file->ERROR != '') {
					$eh =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opn_errorhandler;
					$eh->show ($file->ERROR);
				}
				unset ($file);
			}

		}

		/**
		* Deletes the thumbnails for an image
		*
		* @param $media_id
		* @param $filename
		*/

		function DeleteThumbnails ($media_id, $filename, $path = _PATH_MEDIA) {

			$filename = explode ('.', $filename);
			$index = count ($filename)-1;
			$filename[$index] = '.jpg';
			$filename = implode ('.', $filename);
			$this->DeleteFile ($media_id, 'normal_' . $filename, $path);
			$this->DeleteFile ($media_id, 'thumb_' . $filename, $path);
			$this->DeleteFile ($media_id, 'sidebox_' . $filename, $path);
			$this->DeleteFile ($media_id, 'centerbox_' . $filename, $path);

		}

		/**
		* Copy a mediafile from one dir to another
		*
		* @param $filename
		* @param $media_id
		* @param $pathsrc
		* @param $pathdest
		*/

		function CopyFile ($filename, $media_id, $pathsrc = _PATH_MEDIA, $pathdest = _PATH_MEDIA) {

			$src = $this->getAttachmentFilename ($filename, $media_id, false, false, $pathsrc);
			$dst = $this->getAttachmentFilename ($filename, $media_id, false, false, $pathdest);
			if (file_exists ($src) ) {
				$file =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opnFile ();
				$file->copy_file ($src, $dst, '0666');
				if ($file->ERROR != '') {
					$eh =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opn_errorhandler;
					$eh->show ($file->ERROR);
				}
				unset ($file);
			}

		}

		/**
		* Copy a mediafile from one dir to another with different names
		*
		* @param $srcfilename
		* @param $dstfilename
		* @param $media_id
		* @param $pathsrc
		* @param $pathdest
		*/
		function CopyFileEdit ($srcfilename, $dstfilename, $media_id, $pathsrc = _PATH_MEDIA, $pathdest = _PATH_MEDIA) {

			$src = $this->getAttachmentFilename ($srcfilename, $media_id, false, false, $pathsrc);
			$dst = $this->getAttachmentFilename ($dstfilename, $media_id, false, false, $pathdest);
			if (file_exists ($src) ) {
				$file =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opnFile ();
				$file->copy_file ($src, $dst, '0666');
				if ($file->ERROR != '') {
					$eh =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opn_errorhandler;
					$eh->show ($file->ERROR);
				}
				unset ($file);
			}

		}

		/**
		 * Move a mediafile from one dir to another
		 * 		
		 * @param $filename
		 * @param $media_id
		 * @param $pathsrc
		 * @param $pathdest
		 */
		function MoveFile ($filename, $media_id, $pathsrc = _PATH_MEDIA, $pathdest = _PATH_MEDIA) {

			$src = $this->getAttachmentFilename ($filename, $media_id, false, false, $pathsrc);
			$dst = $this->getAttachmentFilename ($filename, $media_id, false, false, $pathdest);
			if (file_exists ($src) ) {
				$file =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opnFile ();
				$file->move_file ($src, $dst, '0666');
				if ($file->ERROR != '') {
					$eh =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opn_errorhandler;
					$eh->show ($file->ERROR);
				}
				unset ($file);
			}

		}

		/**
		 * Copy the thumbnails from one dir to another
		 * 		
		 * @param $filename
		 * @param $media_id
		 * @param $pathsrc
		 * @param $pathdest
		 */
		function CopyThumbnails($filename, $media_id, $pathsrc = _PATH_MEDIA, $pathdest = _PATH_MEDIA) {

			$filename = explode ('.', $filename);
			$index = count ($filename)-1;
			$filename[$index] = '.jpg';
			$filename = implode ('.', $filename);
			$this->CopyFile ('normal_' . $filename, $media_id, $pathsrc, $pathdest);
			$this->CopyFile ('thumb_' . $filename, $media_id, $pathsrc, $pathdest);
			$this->CopyFile ('sidebox_' . $filename, $media_id, $pathsrc, $pathdest);
			$this->CopyFile ('centerbox_' . $filename, $media_id, $pathsrc, $pathdest);

		}

		/**
		 * Move the thumbnails from one dir to another
		 * 		
		 * @param $filename
		 * @param $media_id
		 * @param $pathsrc
		 * @param $pathdest
		 */
		function MoveThumbnails ($filename, $media_id, $pathsrc = _PATH_MEDIA, $pathdest = _PATH_MEDIA) {

			$filename = explode ('.', $filename);
			$index = count ($filename)-1;
			$filename[$index] = '.jpg';
			$filename = implode ('.', $filename);
			$this->MoveFile ('normal_' . $filename, $media_id, $pathsrc, $pathdest);
			$this->MoveFile ('thumb_' . $filename, $media_id, $pathsrc, $pathdest);
			$this->MoveFile ('sidebox_' . $filename, $media_id, $pathsrc, $pathdest);
			$this->MoveFile ('centerbox_' . $filename, $media_id, $pathsrc, $pathdest);

		}

		/**
		 * Returns the thumbnailname
		 * 
		 * @param $filename
		 * @param $media_id
		 * @param $path
		 * @param $thumbtype
		 * @param $url
		 * @return string
		 */
		function GetThumbnailName ($filename, $media_id, $path, $thumbtype, $url = false) {

			$thumbname = explode ('.', $filename);
			$index = count ($thumbname)-1;
			$thumbname[$index] = '.jpg';
			$thumbname = implode ('.', $thumbname);
			switch ($thumbtype) {
				case _THUMB_NORMAL:
					$thumbname = 'normal_' . $thumbname;
					break;
				case _THUMB_SIDEBOX:
					$thumbname = 'sidebox_' . $thumbname;
					break;
				case _THUMB_CENTERBOX:
					$thumbname = 'centerbox_' . $thumbname;
					break;
				case _THUMB_THUMB:
					$thumbname = 'thumb_' . $thumbname;
					break;
			} /* switch */
			return $this->getAttachmentFilename ($thumbname, $media_id, false, $url, $path);
		}

		/**
		* Create the thumbnails when need.
		*
		* @param $filename
		* @param $media_id
		*/
		function CreateThumbnails ($filename, $media_id, $path, &$imageobject) {

			global $opnConfig;

			$thumbname = explode ('.', $filename);
			$index = count ($thumbname)-1;
			$thumbname[$index] = '.jpg';
			$thumbname = implode ('.', $thumbname);
			$filename1 = $this->getAttachmentFilename ($filename, $media_id, false, false, $path);
			$nwidth = $opnConfig['mediagallery_normal_width'];
			$nheight = $opnConfig['mediagallery_normal_height'];
			$normalname = $this->getAttachmentFilename ('normal_' . $thumbname, $media_id, false, false, $path);
			$swidth = $opnConfig['mediagallery_sidebox_width'];
			$sheight = $opnConfig['mediagallery_sidebox_height'];
			$sideboxname = $this->getAttachmentFilename ('sidebox_' . $thumbname, $media_id, false, false, $path);
			$cwidth = $opnConfig['mediagallery_centerbox_width'];
			$cheight = $opnConfig['mediagallery_centerbox_height'];
			$centerboxname = $this->getAttachmentFilename ('centerbox_' . $thumbname, $media_id, false, false, $path);
			$twidth = $opnConfig['mediagallery_thumb_width'];
			$theight = $opnConfig['mediagallery_thumb_height'];
			$thumbname = $this->getAttachmentFilename ('thumb_' . $thumbname, $media_id, false, false, $path);
			$this->DeleteThumbnails($media_id, $filename, $path);
			$docheck = false;
			if ($opnConfig['mediagallery_clip_thumbnails'] == 1) {
				$docheck = true;
			}
			$this->_build_thumbnail ($filename1, $normalname, $nwidth, $nheight, $imageobject);
			$this->_build_thumbnail ($filename1, $sideboxname, $swidth, $sheight, $imageobject, $docheck);
			$this->_build_thumbnail ($filename1, $centerboxname, $cwidth, $cheight, $imageobject, $docheck);
			$this->_build_thumbnail ($filename1, $thumbname, $twidth, $theight, $imageobject, $docheck);

		}

		/**
		 * Create a previewimage
		 * 
		 * @param $filename
		 * @param $media_id
		 * @param $path
		 * @param $imageobject
		 */
		function CreatePreview ($filename, $media_id, $path, &$imageobject) {
			$thumbname = $this->BuildPreviewName( $filename, $media_id, $path);
			$index = count ($thumbname)-1;
			$filename = $this->getAttachmentFilename ($filename, $media_id, false, false, $path);
			$this->_build_thumbnail ($filename, $thumbname, 149, 119, $imageobject);
		}

		/**
		 * Build the previewimagename
		 * 
		 * @param $filename
		 * @param $media_id
		 * @param $path
		 * @return string
		 */
		function BuildPreviewName ($filename, $media_id, $path, $url = false) {
			$thumbname = explode ('.', $filename);
			$index = count ($thumbname)-1;
			$thumbname[$index] = '.jpg';
			$thumbname = implode ('.', $thumbname);
			$thumbname = $this->getAttachmentFilename ('preview_' . $thumbname, $media_id, false, $url, $path);
			return $thumbname;
		}

		/**
		 * Create a thumbnail
		 * 		
		 * @param $filename
		 * @param $thumbname
		 * @param $width
		 * @param $height
		 * @param $imageobject
		 * @param $docheck
		 */
		function _build_thumbnail ($filename, $thumbname, $width, $height, &$imageobject, $docheck = false) {

			global $opnConfig;

			$file =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opnFile ();
			$file->create_file ($thumbname);
			unset($file);
			$imageobject->SetQuality ($opnConfig['mediagallery_jpeg_quality']);
			$imageobject->CreateThumbnail ($filename, $thumbname, $width, $height, $docheck);
			if ($imageobject->IsError ()) {
				$eh =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opn_errorhandler;
				$eh->show ($imageobject->GetErrorMessages ());

			}
		}

		/**
		 * Returns the filetype of the image
		 * 		
		 * @param $filename
		 * @return integer
		 */
		function get_image_type ($filename , &$imageobject) {

			$imginfo = false;
			$imginfo = $imageobject->GetImageInfo ($filename);
			if ($imageobject->IsError ()) {
				$eh =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opn_errorhandler;
				$eh->show ($imageobject->GetErrorMessages ());
			}
			return $imginfo;
		}

		/**
		* Check the mediafiles that they can be uploaded.
		*
		*/

		function check_upload () {

			global $opnConfig, $opnTables;

			$attachment = array ();
			get_var ('file', $attachment,'file');
			$this->_file_failure = array ();
			$this->_file_success = array ();
			$attach = array ();
			if (count ($attachment) ) {
				$attach = array ();
				$skipattachment = array ();
				foreach ($attachment['name'] as $key => $value) {
					if ($value == '') {
						$skipattachment[$key] = true;
					}
				}
				foreach ($attachment as $key => $value) {
					foreach ($value as $key1 => $val) {
						if (!isset ($skipattachment[$key1]) ) {
							$attach[$key1][$key] = $val;
						}
					}
				}
				$result = $opnConfig['database']->Execute ('SELECT sum(filesize) AS summe FROM ' . $opnTables['mediagallery_pictures'] . ' WHERE approved=1');
				$size = 0;
				if ( ($result !== false) && (isset ($result->fields['summe']) ) ) {
					$size = $result->fields['summe'];
				}
				$disabledFiles = array ('con',
							'com1',
							'com2',
							'com3',
							'com4',
							'prn',
							'aux',
							'lpt1',
							'.htaccess',
							'.htgroup',
							'.htpasswd',
							'index.php',
							'index.html',
							'robots.txt');
				require (_OPN_ROOT_PATH . _OPN_CLASS_SOURCE_PATH . 'class.fileupload.php');
				$keys = array_keys($attach);
				foreach ($keys as $key) {
					if ($attach[$key]['name'] == '') {
						continue;
					}
					if (isset ($attach[$key]['error']) ) {
						if ($attach[$key]['error'] != 0) {
							$this->_file_failure[$key] = array ('filename' => $attach[$key]['name'],
											'errorcode' => '');
							if ($attach[$key]['error'] == 1) {
								$this->_file_failure[$key]['errorcode'] = _ERROR_MEDIAGALLERY_0006;
							} elseif ($attach[$key]['error'] == 2) {
								$this->_file_failure[$key]['errorcode'] = _ERROR_MEDIAGALLERY_0007;
							} elseif ($attach[$key]['error'] == 3) {
								$this->_file_failure[$key]['errorcode'] = _ERROR_MEDIAGALLERY_0008;
							} elseif ($attach[$key]['error'] == 4) {
								$this->_file_failure[$key]['errorcode'] = _ERROR_MEDIAGALLERY_0009;
							} else {
								$this->_file_failure[$key]['errorcode'] = _ERROR_MEDIAGALLERY_0010;
							}
							continue;
						}
					}
					if (!is_uploaded_file ($attach[$key]['tmp_name']) ) {
						$this->_file_failure[$key] = array ('filename' => $attach[$key]['name'],
										'errorcode' => _ERROR_MEDIAGALLERY_0003);
						continue;
					}
					$attach[$key]['name'] = $this->getAttachmentFilename ($attach[$key]['name'], false, true);
					// Is the file too big?
					if ($attach[$key]['size']>$opnConfig['mediagallery_max_filesize']*1024) {
						$this->_file_failure[$key] = array ('filename' => $attach[$key]['name'],
										'errorcode' => sprintf (_ERROR_MEDIAGALLERY_0004,
										$opnConfig['mediagallery_max_filesize']) );
						continue;
					}
					if (!$this->_mediafunctions->is_known_filetype ($attach[$key]['name']) ) {
						$this->_file_failure[$key] = array ('filename' => $attach[$key]['name'],
										'errorcode' => _ERROR_MEDIAGALLERY_0002);
						continue;
					}
					// Too big!  Maybe you could zip it or something...
					if ($attach[$key]['size']+$size>$opnConfig['mediagallery_dir_size_limit']*1024) {
						$this->_file_failure[$key] = array ('filename' => $attach[$key]['name'],
										'errorcode' => _ERROR_MEDIAGALLERY_0001);
						continue;
					}
					$destName = basename ($attach[$key]['name']);
					if (in_array (strtolower ($destName), $disabledFiles) ) {
						$this->_file_failure[$key] = array ('filename' => $attach[$key]['name'],
										'errorcode' => sprintf (_ERROR_MEDIAGALLERY_0005,
										$destName) );
						continue;
					}
					$attach1 = $attach[$key];
					$attach1['name'] = $this->getAttachmentFilename ($attach1['name'], false, false, false, _PATH_UPLOAD);
					set_var ('userupload', $attach1, 'file');
					$upload =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ file_upload_class;
					if ($upload->upload ('userupload', '', '') ) {
						if ($upload->save_file ($opnConfig['datasave']['mediagallery_upload']['path'], 2, false, false) ) {
							$attach1['name'] = basename ($upload->new_file);
						}
					}
					unset_var ('userupload', 'file');
					if (count ($upload->errors) ) {
						$hlp = '';
						$uploaded = false;
						foreach ($upload->errors as $var) {
							$this->_file_failure[$key] = array ('filename' => $attach[$key]['name'],
											'errorcode' => $var );
						}
						continue;
					}
					unset ($upload);
					$attach[$key] = $attach1;
					if ($this->_mediafunctions->is_image ($attach[$key]['name']) ) {
						$image = $opnConfig['datasave']['mediagallery_upload']['path'] . $attach[$key]['name'];
						$imageobject = loadDriverImageObject ( $opnConfig['datasave']['mediagallery_upload']['path'], $attach[$key]['name']);
						$imageobject->SetQuality ($opnConfig['mediagallery_jpeg_quality']);
						$imginfo = $this->get_image_type ($image, $imageobject);
						if ($imginfo === false ) {
							$this->DeleteFile (0, $attach[$key]['name'], _PATH_UPLOAD);
							$this->_file_failure[$key] = array ('filename' => $attach[$key]['name'],
											'errorcode' => _ERROR_MEDIAGALLERY_0011 );
							continue;
						}
						if (($imginfo[2] != IMAGETYPE_JPEG) && ($imginfo[2] != IMAGETYPE_PNG) && ($opnConfig['mediagallery_libtype'] == 0)) {
							$this->DeleteFile (0, $attach[$key]['name'], _PATH_UPLOAD);
							$this->_file_failure[$key] = array ('filename' => $attach[$key]['name'],
											'errorcode' => _ERROR_MEDIAGALLERY_0012 );
							continue;
						}
						if (!$opnConfig['mediagallery_do_resize']) {
							if ($imginfo[0] > $opnConfig['mediagallery_max_width']) {
								$this->DeleteFile (0, $attach[$key]['name'], _PATH_UPLOAD);
								$this->_file_failure[$key] = array ('filename' => $attach[$key]['name'],
												'errorcode' => _ERROR_MEDIAGALLERY_0013 );
								continue;
							}
							if ($imginfo[1] > $opnConfig['mediagallery_max_height']) {
								$this->DeleteFile (0, $attach[$key]['name'], _PATH_UPLOAD);
								$this->_file_failure[$key] = array ('filename' => $attach[$key]['name'],
												'errorcode' => _ERROR_MEDIAGALLERY_0014 );
								continue;
							}
						}
						if ($opnConfig['mediagallery_convert_to_jpg']) {
							if (!$this->_mediafunctions->is_browser_image ($attach[$key]['name'])) {
								$newname = $this->_mediafunctions->Convert_To_JPG ($attach[$key]['name']);
								$new = $this->getAttachmentFilename ($newname, 0, false, false, _PATH_UPLOAD);
								$old = $this->getAttachmentFilename ($attach[$key]['name'], 0, false, false, _PATH_UPLOAD);
								$imageobject->ConvertImage ($old, $new);
								unset($image);
								$this->DeleteFile (0, $attach[$key]['name'], _PATH_UPLOAD);
								$attach[$key] = $newname;
							}
						}
						unset($imageobject);
					}
					$this->_file_success[$key] = array ('filename' => $attach[$key]['name'],
									'value' => $attach[$key]);
					$size += $attach[$key]['size'];
				}
			}

		}

	}
}

?>