<?php
/*
* OpenPHPNuke: Great Web Portal System
*
* Copyright (c) 2001-2006 by
* Heinz Hombergs heinz@hhombergs.de
* Stefan Kaletta stefan@kaletta.de
* Alexander Weber xweber@kamelfreunde.de
*
* This program is free software. You can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License.
* See LICENSE for details.
*
* This software is based on various code found in the internet
* See CREDITS for details
* If you are an author of a part of opn and not you are not mentioned
* SORRY for that ! We respect your rights to your code, so please send
* an eMail to devteam@openphpnuke.com we will include you to the CREDITS asap
*/
if (!defined ('_OPN_CLASS_IMAGEOBJECT_GD_INCLUDED') ) {
	define ('_OPN_CLASS_IMAGEOBJECT_GD_INCLUDED', 1);

	class imageobject_gd extends imageobject {

		/**
		 * Class constructor for PHP 5
		 * 		
		 * @param $directory
		 * @param $filename
		 */
		function /*<{4php5}>imageobject_gd!!__construct<{4php5/}>*//*<{delete}>*/imageobject_gd/*<{delete/}>*/ ($directory, $filename) {

			$this->PerformParams ($directory, $filename);

		}

		/**
		 * Set's the needed params
		 * 
		 * @param string $directory
		 * @param string $filename
		 */
		function PerformParams ($directory, $filename) {

			$this->SetParams ($directory, $filename);
			if (file_exists ($directory . $filename) ) {
				$this->_filesize = round (filesize ($this->_fullname)/1000);
				if ($this->_filesize>0) {
					$size = $this->GetImageInfo ($this->_fullname);
					if ($size) {
						$this->_imgRes = $this->_getimgRes ($this->_fullname, $size[2]);
					}
					if (function_exists ("imagecreatetruecolor") ) {
						$this->_truecolor = true;
					}
					$this->_width = $size[0];
					$this->_height = $size[1];
					$this->_string = $size[3];
				}
			}
			// if

		}

		/**
		* Crop an image
		*
		* @param $clipval
		* @access public
		*/

		function cropImage (&$clipval) {

			$cliparray = split (",", $clipval);
			$clip_top = $cliparray[0];
			$clip_right = $cliparray[1];
			$clip_bottom = $cliparray[2];
			$clip_left = $cliparray[3];
			$new_w = $clip_right- $clip_left;
			$new_h = $clip_bottom- $clip_top;
			$dst_img = $this->_createImage ($new_w, $new_h);
			$result = @imagecopyresampled ($dst_img, $this->_imgRes, 0, 0, $clip_left, $clip_top, $new_w, $new_h, $new_w, $new_h);
			if (!$result) {
				$result = @imagecopyresized ($dst_img, $this->_imgRes, 0, 0, $clip_left, $clip_top, $new_w, $new_h, $new_w, $new_h);
			}
			$this->_createUnique ($dst_img);
			$this->PerformParams ($this->_directory, $this->_filename);

		}

		/**
		* Resize an image
		*
		* @param int	$new_w	new width
		* @param int	$new_h	new height
		* @access public
		*/

		function resizeImage ($new_w = 0, $new_h = 0) {

			$dst_img = $this->_createImage ($new_w, $new_h);
			$result = @imagecopyresampled ($dst_img, $this->_imgRes, 0, 0, 0, 0, $new_w, $new_h, $this->_width, $this->_height);
			if (!$result) {
				$result = @imagecopyresized ($dst_img, $this->_imgRes, 0, 0, 0, 0, $new_w, $new_h, $this->_width, $this->_height);
			}
			$this->_createUnique ($dst_img);
			$this->PerformParams ($this->_directory, $this->_filename);

		}

		/**
		* Rotate an image
		*
		* @param $angle
		* @access public
		*/

		function rotateImage (&$angle) {
			if ($angle == 180) {
				$dst_img = @imagerotate ($this->_imgRes, $angle, 0);
			} else {
				$width = imagesx ($this->_imgRes);
				$height = imagesy ($this->_imgRes);
				if ($width>$height) {
					$size = $width;
				} else {
					$size = $height;
				}
				$dst_img = $this->_createImage ($size, $size);
				imagecopy ($dst_img, $this->_imgRes, 0, 0, 0, 0, $width, $height);
				$dst_img = @imagerotate ($dst_img, $angle, 0);
				$this->_imgRes = $dst_img;
				$dst_img = $this->_createImage ($height, $width);
				if ( ( ($angle == 90) && ($width>$height) ) || ( ($angle == 270) && ($width<$height) ) ) {
					imagecopy ($dst_img, $this->_imgRes, 0, 0, 0, 0, $size, $size);
				}
				if ( ( ($angle == 270) && ($width>$height) ) || ( ($angle == 90) && ($width<$height) ) ) {
					imagecopy ($dst_img, $this->_imgRes, 0, 0, $size- $height, $size- $width, $size, $size);
				}
			}
			$this->_createUnique ($dst_img);
			$this->PerformParams ($this->_directory, $this->_filename);

		}

		/**
		 * Mirror an image horizontal, vertical or both
		 * 		
		 * @param $type
		 */
		function mirrorImage ($type) {

			$width = imagesx($this->_imgRes);
			$height = imagesy($this->_imgRes);

			$imgdest = imagecreatetruecolor($width, $height);
			ImageAlphaBlending($imgdest, false);

			switch ($type) {
				case _MIRROR_FLOP:
					for ( $y=0 ; $y<$height ; $y++ ) {
						imagecopy($imgdest, $this->_imgRes, 0, $height-$y-1, 0, $y, $width, 1);
					}
					break;
				case _MIRROR_FLIP:
					for ( $x=0 ; $x<$width ; $x++ ) {
						imagecopy($imgdest, $this->_imgRes, $width-$x-1, 0, $x, 0, 1, $height);
					}
					break;
				case _MIRROR_FLIPFLOP:
					for ( $x=0 ; $x<$width ; $x++ ) {
						imagecopy($imgdest, $this->_imgRes, $width-$x-1, 0, $x, 0, 1, $height);
					}
					$rowBuffer = imagecreatetruecolor($width, 1);
					for ( $y=0 ; $y<($height/2) ; $y++ ) {
						imagecopy($rowBuffer, $imgdest  , 0, 0, 0, $height-$y-1, $width, 1);
						imagecopy($imgdest  , $imgdest  , 0, $height-$y-1, 0, $y, $width, 1);
						imagecopy($imgdest  , $rowBuffer, 0, $y, 0, 0, $width, 1);
					}
					imagedestroy( $rowBuffer );
					break;
			} /* switch */
			$this->_createUnique ($imgdest);
			$this->PerformParams ($this->_directory, $this->_filename);
		}

		/**
		* Get the imageinfo array
		*
		* @param $filename
		* @access public
		* @return mixed bool or array
		*/

		function GetImageInfo ($filename) {
			if (!file_exists ($filename) ) {
				return false;
			}
			$imginfo = @getimagesize ($filename);
			if ($imginfo === false) {
				return false;
			}
			return $imginfo;

		}

		/**
		* Creates a thumbnail for the image
		*
		* @param $filename
		* @param $thumbname
		* @param $width
		* @param $height
		* @param $docheck
		* @return bool
		*/
		function CreateThumbnail ($filename, $thumbname, $width, $height, $docheck = false) {

			$imginfo = $this->GetImageInfo ($filename);
			$src_img = $this->_getimgRes ($filename, $imginfo[2]);
			$w = $imginfo[0];
			$h = $imginfo[1];
			if ($width > $w) {
				$width = $w;
			}
			if ($height > $h) {
				$height = $h;
			}
			if ($this->_prop_resize) {
				$ratioh = $h / $w;
				$ratiow = $w / $h;
				if ($docheck) {
					if ($w < $h) {
						$height = ceil ($width * $ratioh);
					} elseif ($h < $w) {
						$width = ceil ($height * $ratiow);
					}
				} else {
					// Proportionally resize the image to the
					// max sizes specified above
					$ratio= $w / $h;
					if ($w > $h) {
						$height = ceil ($height / $ratio);
					} elseif ($w < $h) {
						$width = ceil ($height * $ratio);
					}
				}
			}
			$dst_img = $this->_createImage ($width, $height);
			imagecopyresampled ($dst_img, $src_img, 0, 0, 0, 0, $width, $height, $w, $h);
			imagejpeg ($dst_img, $thumbname, $this->_quality);
			imagedestroy ($dst_img);
			imagedestroy ($src_img);
			return true;

		}

		/**
		* Converts an image to a another format (normaly JPG).
		*
		* @param $filename
		* @param $convertname
		* @return bool
		*/

		function ConvertImage ($filename, $convertname) {

			$imginfo = $this->GetImageInfo ($filename);
			$src_img = $this->_getimgRes ($filename, $imginfo[2]);
			$dst_img = $this->_createImage ($imginfo[0], $imginfo[1]);
			imagecopyresampled ($dst_img, $src_img, 0, 0, 0, 0, $imginfo[0], $imginfo[1], $imginfo[0], $imginfo[1]);
			imagejpeg ($dst_img, $convertname, $this->_quality);
			imagedestroy ($src_img);
			imagedestroy ($dst_img);
			return true;

		}

		/**
		 * Size an image
		 * 		
		 * @param $width
		 * @param $height
		 * @return boolean
		 */
		function SizeImage ($width, $height) {

			$dst_img = $this->_createImage ($width, $height);
			$result = @imagecopyresampled ($dst_img, $this->_imgRes, 0, 0, 0, 0, $width, $height, $this->_width, $this->_height);
			if (!$result) {
				$result = @imagecopyresized ($dst_img, $this->_imgRes, 0, 0, 0, 0, $width, $height, $this->_width, $this->_height);
			}
			imagejpeg ($dst_img, $this->_fullname, $this->_quality);
			imagedestroy ($dst_img);
			return true;
		}

		// private methods

		/**
		* Create a new imageressource
		*
		* @param $name
		* @param $type
		* @access private
		* @return ressource
		*/

		function _getimgRes ($name, &$type) {
			switch ($type) {
				case IMAGETYPE_GIF:
					$im = imagecreatefromgif ($name);
					break;
				case IMAGETYPE_JPEG:
					$im = imagecreatefromjpeg ($name);
					break;
				case IMAGETYPE_PNG:
					$im = imagecreatefrompng ($name);
					break;
				default:
					opnErrorHandler (E_WARNING, 'Unkown Imagetype ' . $type, __FILE__, __LINE__);
					break;
			}
			return $im;

		}

		/**
		* Create a new imageobject_gd object
		*
		* @param $imgnew
		* @access private
		*/

		function &_createUnique (&$imgnew) {

			srand ((double)microtime ()*100000);
			$unique_str = "temp_" . md5 (rand (0, 999999) ) . ".jpg";
			@imagejpeg ($imgnew, $this->_directory . $unique_str, $this->_quality);
			@imagedestroy ($this->_imgRes);
			@imagedestroy ($imgnew);
			// Don't clutter with old images
			$file =  /*<{4php5}>& new!!new<{4php5/}>*//*<{delete}>*/& new/*<{delete/}>*/ opnFile ();
			$file->delete_File ($this->_fullname);
			$file->move_file ($this->_directory . $unique_str, $this->_fullname);
			unset ($file);

		}

		/**
		* Create a new Image
		*
		* @param $new_w
		* @param $new_h
		* @access private
		* @return ressource
		*/

		function _createImage ($new_w, $new_h) {
			if (function_exists ("imagecreatetruecolor") ) {
				$retval = @imagecreatetruecolor ($new_w, $new_h);
			}
			if (!$retval) {
				$retval = imagecreate ($new_w, $new_h);
			}
			return $retval;

		}

	}
}

?>